IMPLEMENTATION MODULE ClientsAux ;

  (*

        Implementation and Revisions:
        ============================

        Author  Date        Description
        ------  ----        -----------
		dg		5.12.89		

  *)

  FROM DMFiles IMPORT
    Response, HiddenFileInfo, IOMode, TextFile, GetExistingFile, 
    CreateNewFile, Lookup, Close, Delete, Rename, Reset, Rewrite, 
    EOF, Again, ReadByte, WriteByte, EOL, ReadChar, SkipGap, 
    ReadChars, WriteChar, WriteEOL, WriteChars, legalNum, 
    GetCardinal, PutCardinal, GetInteger, PutInteger, GetReal, 
    PutReal, PutRealSci;        

  IMPORT DMFiles ;
  
  FROM DMWindows IMPORT Window, nonexistent, WindowKind, 
    ScrollBars, CloseAttr, ZoomAttr, WFFixPoint, WindowFrame, 
    CreateWindow, AutoRestoreProc, WindowExists, 
    RemoveWindow, NoBackground;                        

  FROM DMWindowIO IMPORT CellHeight, SetPos, (*. WriteString, WriteLn,
    Write, .*) SetWindowFont, WindowFont, FontStyles, FontStyle,
    BackgroundWidth, BackgroundHeight, SelectForOutput, EraseContent;
  
  IMPORT DMWindowIO ;
  
  FROM DMConversions IMPORT IntToString, CardToString;

  (*. IMPORT Terminal ; .*)

(*.*****************************************************************.*)
  	
  VAR
    str: ARRAY [0..63] OF CHAR;
    jrnlW: Window ;
    
  PROCEDURE MakeWindow;
    VAR wf: WindowFrame; 
  BEGIN
    wf.w:= ( BackgroundWidth() - 16 );
    wf.h:= ( BackgroundHeight() - 32 );
    wf.x:= ( 8 ); 
    wf.y:= ( 8 ); 
    CreateWindow(jrnlW,
                 FixedSize,WithoutScrollBars,
                 WithoutCloseBox,WithoutZoomBox,bottomLeft, wf,
                 'Clients Analysis', AutoRestoreProc);
    SetWindowFont(Monaco,9,FontStyle{});
  END MakeWindow;

  PROCEDURE Write(ch: CHAR);
  BEGIN
    DMWindowIO.Write(ch);
    IF writeOnFile THEN WriteChar(outF,ch) END;
  END Write;
  
  PROCEDURE WriteString(str: ARRAY OF CHAR);
  BEGIN
    DMWindowIO.WriteString(str);
    IF writeOnFile THEN WriteChars(outF,str) END;
  END WriteString;
  
  PROCEDURE WriteLn;
  BEGIN
    DMWindowIO.WriteLn;
    IF writeOnFile THEN WriteEOL(outF) END;
    Write(" ");
  END WriteLn;
  
  PROCEDURE WriteCardinal(card: CARDINAL; lgth: CARDINAL );
  BEGIN
    CardToString(card, str, lgth);
    WriteString(str);
  END WriteCardinal;
  
  PROCEDURE WriteInteger(int: INTEGER; lgth: CARDINAL );
  BEGIN
    IntToString(int, str, lgth);
    WriteString(str);
  END WriteInteger;


  CONST  nul = 00C ;
  
  PROCEDURE CompareStr( str1, str2: ARRAY OF CHAR ): INTEGER;
    VAR  i: INTEGER;
  BEGIN
    i:= 0;
    LOOP
      IF ( i  >   HIGH(str1) ) THEN RETURN  -1;  END;
      IF ( i  >   HIGH(str2) ) THEN RETURN  +1;  END;
      IF ( str1[i] < str2[i] ) THEN RETURN  -1;  END;
      IF ( str1[i] > str2[i] ) THEN RETURN  +1;  END;
      IF ( str1[i] = nul     ) THEN RETURN   0;  END;
      IF (i = HIGH(str1)) & (i = HIGH(str2)) THEN RETURN  0;  END;
      IF (i = HIGH(str1)) & (i < HIGH(str2)) & (str2[i+1] = nul) THEN
        RETURN  0;
      END;
      IF (i < HIGH(str1)) & (i = HIGH(str2)) & (str1[i+1] = nul) THEN
        RETURN  0;
      END;
      INC( i );
    END; (* LOOP *)
  END CompareStr ;
  
  PROCEDURE Read(VAR ch: CHAR);
  BEGIN
    (*. Terminal.Read(ch) .*)
  END Read;
  
  PROCEDURE BusyRead(VAR ch: CHAR);
  BEGIN
    (*. Terminal.BusyRead(ch) .*)
  END BusyRead;

BEGIN
  str[0] := 0C ;
  writeOnFile := FALSE ;
  killed := FALSE ;
  MakeWindow ;
END ClientsAux .
